#include <iostream>
#include <iomanip>
#include <locale>

void show_locale(const std::locale& loc) {
	auto orig = std::cout.imbue(loc);
	std::cout << "Locale: " << loc.name() << '\n'
	          << "int: " << 1024 << '\n'
	          << "double: " << 3.14 << "\n\n";
	std::cout.imbue(orig);
	// exercise for the reader: use RAII to imbue a stream with a locale
	// and return it to the original locale at scope exit
}

int main() {
	show_locale(std::locale::classic());  // C
	show_locale(std::locale{ "" }); // user
	show_locale(std::locale{ "cs_CZ.UTF-8" });

	auto s1 = std::to_string(3.14);
	auto orig = std::locale::global(std::locale{ "cs_CZ.UTF-8" });
	auto s2 = std::to_string(3.14);
	std::locale::global(orig);

	std::cout << s1 << ' ' << s2 << '\n';
}
