#include <iostream>

struct chess_pos {
	int x;
	int y;

	friend std::ostream& operator<<(std::ostream& out,
	                                const chess_pos& pos) {
		return out << static_cast<char>(pos.x + 'a')
		           << pos.y + 1;
	}

	friend std::istream& operator>>(std::istream& in,
	                                chess_pos& pos) {
		char cx, cy;
		if (in >> cx && cx >= 'a' && cx <= 'h' &&
		    in >> cy && cy >= '1' && cy <= '8') {
			pos.x = cx - 'a';
			pos.y = cy - '1';
		} else {
			in.setstate(std::ios::failbit);
		}
		return in;
	}
};

int main() {
	chess_pos cp = { 3, 5 };
	std::cout << cp << '\n';
	if (std::cin >> cp) {
		std::cout << "Okay, read: " << cp << '\n';
	} else {
		std::cout << "Bad chess position.\n";
	}
}
