#include <iomanip>
#include <iostream>

struct bad_byte {
	unsigned char c;

	friend std::ostream& operator<<(std::ostream& out, const bad_byte& b) {
		return out << std::hex << static_cast<int>(b.c);
	}
};

struct good_byte {
	unsigned char c;

	friend std::ostream& operator<<(std::ostream& out, const good_byte& b) {
		auto orig = out.flags();
		out << std::hex << static_cast<int>(b.c);
		out.flags(orig);
		return out;
		// exercise for the reader: rewrite this using a RAII object
	}
};

int main() {
	std::cout << bad_byte{ 42 } << '\n';
	std::cout << 100 << '\n';  // uh, oh

	std::cout << std::dec;

	std::cout << good_byte{ 42 } << '\n';
	std::cout << 100 << '\n';  // all is well
}
