#include <format>
#include <iostream>
#include <map>
#include <print>
#include <ranges>
#include <set>
#include <tuple>
#include <vector>

// needs C++23; currently only supported by libc++ version ≥ 17
// compile using: clang++ -std=c++23 -stdlib=libc++

int main() {
	std::println("Finally!");

	std::vector v = { 1, 3, 3, 7 };
	std::set s = { 42, 17 };
	std::map<char, int> m = { { 'i', 1 }, { 'v', 5 }, { 'x', 10 } };

	std::println("vector: {}\nset: {}\nmap: {}", v, s, m);

	std::println("no brackets: {:n}", v);

	std::println("tuple: {}", std::tuple{ 1, 2, 3 });

	namespace views = std::views;

	std::println("view: {}", views::iota(1, 10));

	std::println("hex: {::#x}", views::iota(10, 20));
}
